"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.AutomatonElement = exports.AutomatonStack = exports.Checkpoint = exports.Token = exports.LocatedToken = exports.Position = exports.LexBuffer = exports.ExpressionEval = exports.Expression = exports.Script = exports.Parser = exports.ParseError = exports.LexError = exports.OCamlError = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _wrapNativeSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/wrapNativeSuper"));

var _ocamlStringConvert = require("ocaml-string-convert");

var _aST = _interopRequireDefault(require("./aST.bs"));

var _lexer = _interopRequireDefault(require("./lexer.bs"));

var _parser = _interopRequireDefault(require("./parser.bs"));

var _expression = _interopRequireDefault(require("./expression.bs"));

var _incremental = _interopRequireDefault(require("./incremental.bs"));

/** @hidden */
var INTERNAL = Symbol();

// Errors
var OCamlError =
/*#__PURE__*/
function (_Error) {
  (0, _inherits2["default"])(OCamlError, _Error);

  /** @hidden */
  function OCamlError($exn, message) {
    var _this;

    (0, _classCallCheck2["default"])(this, OCamlError);
    // FIXME: This is fragile; I'm depending on the BuckleScript runtime-repr of `exn`, here ...
    console.assert(Array.isArray($exn) && Array.isArray($exn[0]) && typeof $exn[0][0] === 'string');

    var _$exn = (0, _slicedToArray2["default"])($exn, 2),
        _$exn$ = (0, _slicedToArray2["default"])(_$exn[0], 2),
        error_variant = _$exn$[0],
        _ = _$exn$[1],
        __ = _$exn[1];

    if (typeof message === 'string' && message.length > 0) {
      _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(OCamlError).call(this, message));
    } else if (typeof error_variant === 'string') {
      _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(OCamlError).call(this, 'OCaml exception: ' + error_variant));
    } else {
      _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(OCamlError).call(this, 'Unknown OCaml exception.'));
    }

    _this.$exn = $exn; // Set the prototype explicitly. See:
    //    <https://github.com/Microsoft/TypeScript/wiki/Breaking-Changes#extending-built-ins-like-error-array-and-map-may-no-longer-work>

    Object.setPrototypeOf((0, _assertThisInitialized2["default"])(_this), OCamlError.prototype);
    return (0, _possibleConstructorReturn2["default"])(_this);
  }

  return OCamlError;
}((0, _wrapNativeSuper2["default"])(Error));

exports.OCamlError = OCamlError;

var LexError =
/*#__PURE__*/
function (_OCamlError) {
  (0, _inherits2["default"])(LexError, _OCamlError);

  function LexError($exn) {
    var _this2;

    (0, _classCallCheck2["default"])(this, LexError);

    var _$exn2 = (0, _slicedToArray2["default"])($exn, 3),
        _$exn2$ = (0, _slicedToArray2["default"])(_$exn2[0], 2),
        $error_variant = _$exn2$[0],
        _ = _$exn2$[1],
        $pos = _$exn2[1],
        $message = _$exn2[2],
        message = (0, _ocamlStringConvert.fromFakeUTF8String)($message),
        pos = new Position(INTERNAL, $pos);

    var print;

    if (typeof message === 'string' && message.length > 0) {
      print = "".concat(message, " (").concat(pos.filename, ":").concat(pos.line, ":").concat(pos.character, ")");
    } else {
      print = "Unknown LexError (".concat(pos.filename, ":").concat(pos.line, ":").concat(pos.character, ")");
    }

    _this2 = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(LexError).call(this, $exn, print));
    _this2.name = 'LexError';
    _this2.pos = pos;
    Object.setPrototypeOf((0, _assertThisInitialized2["default"])(_this2), LexError.prototype);
    return _this2;
  }

  return LexError;
}(OCamlError);

exports.LexError = LexError;

var ParseError =
/*#__PURE__*/
function (_OCamlError2) {
  (0, _inherits2["default"])(ParseError, _OCamlError2);

  function ParseError($exn) {
    var _this3;

    (0, _classCallCheck2["default"])(this, ParseError);

    var _$exn3 = (0, _slicedToArray2["default"])($exn, 2),
        _$exn3$ = (0, _slicedToArray2["default"])(_$exn3[0], 2),
        $error_variant = _$exn3$[0],
        _ = _$exn3$[1],
        $loctok = _$exn3[1];

    _this3 = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(ParseError).call(this, $exn));
    _this3.name = 'ParseError';
    _this3.token = new LocatedToken(INTERNAL, $loctok);
    Object.setPrototypeOf((0, _assertThisInitialized2["default"])(_this3), ParseError.prototype);
    return _this3;
  }

  return ParseError;
}(OCamlError);
/** @hidden */


exports.ParseError = ParseError;
var errorMap = {
  'Lexer.LexError': LexError,
  'Parser.ParseError': ParseError // Helpers

  /** @hidden */

};

function isOCamlExn($exn) {
  return Array.isArray($exn) && Array.isArray($exn[0]) && typeof $exn[0][0] === 'string';
}
/**
 * Call a BuckleScript-generated OCaml function, catch OCaml `exn`-type exceptions, attempt to wrap
 * them in a JavaScript-side `Error`-descendant, and then throw them. Naturally, *this function*
 * will show up in the stack-trace — that is perfectly fine, as OCaml `exn`s *don't actually
 * maintain a stack*, as a performance trade-off; thus, no information is being lost here.
 *
 * @hidden
 */


function buckleScriptErrorTrampoline(bs_function) {
  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  try {
    return bs_function.apply(null, args);
  } catch ($exn) {
    if (isOCamlExn($exn)) {
      var _$exn4 = (0, _slicedToArray2["default"])($exn, 1),
          _$exn4$ = (0, _slicedToArray2["default"])(_$exn4[0], 1),
          error_variant = _$exn4$[0];

      if (error_variant === 'Caml_js_exceptions.Error') {
        var orig_error = $exn[1];
        throw orig_error;
      } else {
        var ErrorConstructor = errorMap[error_variant] || OCamlError;
        throw new ErrorConstructor($exn);
      }
    } else {
      throw $exn;
    }
  }
}
/**
 * Meta-programmatic nonsense to translate all errors occuring in BuckleScript-land.
 * @hidden
 */


function mapExposedFunctionsThruErrorTrampoline($module) {
  for (var exposed in $module) {
    if ($module.hasOwnProperty(exposed)) {
      var $func = $module[exposed];

      if ($func instanceof Function) {
        $module[exposed] = buckleScriptErrorTrampoline.bind(null, $func);
      }
    }
  }
}

;
[_aST["default"], _lexer["default"], _parser["default"], _expression["default"], _incremental["default"]].forEach(mapExposedFunctionsThruErrorTrampoline);
/** @hidden */

function fromFakeUTF8StringOption($str) {
  if (typeof $str === 'undefined') {
    return undefined;
  } else {
    return (0, _ocamlStringConvert.fromFakeUTF8String)($str);
  }
}
/**
 * Yes, this is basically a no-op; but I like to be explicit. >,>
 * @hidden
 */


function fromFlagPayloadOption($payloadOpt) {
  if (typeof $payloadOpt === 'undefined') {
    // `None`
    return undefined;
  } else {
    var $payload = _expression["default"].payload_to_opt($payloadOpt);

    if (typeof $payload === 'undefined') {
      // `Some Empty`
      return undefined;
    } else {
      // `Some (Payload (string or_subexpr))`
      return $payload;
    }
  }
}
/**
 * As opposed to [[Sub]]; represents simple, directly-embedded `string`s in the AST. These are
 * the values that are immediately available, and do not need further evaluation.
 *
 * (Functions that return this are usually also available as `eval*` versions that help you
 * interpret subexpressions recursively; see [[Expression]] for more information.)
 */


// Helper to generate a JavaScript-friendly shape for an `AST.or_subexpr`

/** @hidden */
function fromOrSubexpr($x) {
  if (_aST["default"].is_literal($x)) {
    var $val = _aST["default"].get_literal_exn($x);

    return {
      type: 'literal',
      value: (0, _ocamlStringConvert.fromFakeUTF8String)($val)
    };
  } else {
    var $expr = _aST["default"].get_sub_exn($x);

    return {
      type: 'subexpression',
      expr: new Expression(INTERNAL, $expr)
    };
  }
}
/**
 * Helper to generate a JavaScript-friendly shape for an `AST.or_subexpr`, as `fromOrSubexpr`; but
 * producing `ExpressionEval`s instead of `Expression`s for subexpressions.
 * @hidden
 */


function fromOrSubexprWithEval(evl, $x) {
  if (_aST["default"].is_literal($x)) {
    var $val = _aST["default"].get_literal_exn($x);

    return {
      type: 'literal',
      value: (0, _ocamlStringConvert.fromFakeUTF8String)($val)
    };
  } else {
    var $expr = _aST["default"].get_sub_exn($x);

    return {
      type: 'subexpression',
      expr: new ExpressionEval(INTERNAL, $expr, evl)
    };
  }
}
/** @hidden */


function reduceOrSubexprWithEval(evl, $x) {
  if (_aST["default"].is_literal($x)) {
    var $val = _aST["default"].get_literal_exn($x);

    return (0, _ocamlStringConvert.fromFakeUTF8String)($val);
  } else {
    var $expr = _aST["default"].get_sub_exn($x),
        _expr = new ExpressionEval(INTERNAL, $expr, evl);

    return evl.call(null, _expr);
  }
} // Wrapper for Parser.script


function script(lexbuf) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  console.assert(lexbuf instanceof LexBuffer);

  var $scpt = _parser["default"].script(options.throwException, lexbuf.$buf);

  if (typeof $scpt === 'undefined') {
    return undefined;
  } else {
    return new Script(INTERNAL, $scpt);
  }
} // Equivalent of Parser.script_of_string


function scriptOfString(str) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var lexbuf = LexBuffer.ofString(str);
  return script(lexbuf, options);
} // Wrapper for Incremental.script


function startScript(lexbuf) {
  console.assert(lexbuf instanceof LexBuffer);

  var $cp = _incremental["default"].script(lexbuf.$buf);

  return new Checkpoint(INTERNAL, $cp, 'script');
} // Equivalent of Incremental.script_of_string


function startScriptWithString(str) {
  var lexbuf = LexBuffer.ofString(str);
  return startScript(lexbuf);
}

function expression(lexbuf) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  console.assert(lexbuf instanceof LexBuffer);

  var $expr = _parser["default"].expression(options.throwException, lexbuf.$buf);

  if (typeof $expr === 'undefined') {
    return undefined;
  } else {
    return new Expression(INTERNAL, $expr);
  }
}

function expressionOfString(str) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var lexbuf = LexBuffer.ofString(str);
  return expression(lexbuf, options);
} // Wrapper for Incremental.script


function startExpression(lexbuf) {
  console.assert(lexbuf instanceof LexBuffer);

  var $cp = _incremental["default"].expression(lexbuf.$buf);

  return new Checkpoint(INTERNAL, $cp, 'expression');
} // Equivalent of Incremental.script_of_string


function startExpressionWithString(str) {
  var lexbuf = LexBuffer.ofString(str);
  return startExpression(lexbuf);
}

var Parser = {
  script: script,
  scriptOfString: scriptOfString,
  startScript: startScript,
  startScriptWithString: startScriptWithString,
  expression: expression,
  expressionOfString: expressionOfString,
  startExpression: startExpression,
  startExpressionWithString: startExpressionWithString // Wrapper for `AST.t`.

};
exports.Parser = Parser;

var Script =
/*#__PURE__*/
function () {
  /** @hidden */

  /** @hidden */
  function Script(isInternal, $scpt) {
    (0, _classCallCheck2["default"])(this, Script);
    if (isInternal !== INTERNAL) throw new Error('`Script` can only be constructed by `Excmd.script()` and friends.');
    this.$scpt = $scpt;
    this.$expressions = _expression["default"].from_script(this.$scpt);
  }

  (0, _createClass2["default"])(Script, [{
    key: "expressions",
    get: function get() {
      return this.$expressions.map(function ($expr) {
        return new Expression(INTERNAL, $expr);
      });
    }
  }]);
  return Script;
}();

exports.Script = Script;

var ExpressionCommon =
/*#__PURE__*/
function () {
  /** @hidden */
  function ExpressionCommon(isInternal, $expr) {
    (0, _classCallCheck2["default"])(this, ExpressionCommon);
    if (isInternal !== INTERNAL) throw new Error('`Expression` can only be constructed by `Excmd.script()` and friends.');
    this.$expr = $expr;
  }

  (0, _createClass2["default"])(ExpressionCommon, [{
    key: "hasFlag",
    // Wrapper for `Expression.mem`
    value: function hasFlag(flag) {
      console.assert(typeof flag === 'string');
      var $flag = (0, _ocamlStringConvert.toFakeUTF8String)(flag);
      return _expression["default"].mem($flag, this.$expr);
    }
  }, {
    key: "count",
    get: function get() {
      return _expression["default"].count(this.$expr);
    }
  }, {
    key: "flags",
    get: function get() {
      return _expression["default"].flags_arr(this.$expr).map(_ocamlStringConvert.fromFakeUTF8String);
    }
  }]);
  return ExpressionCommon;
}();
/**
 * The core type of my AST, this data-structure represents a single (sub-)command in an excmd
 * script; and is the product of entry-points like [[Parser.expressionOfString]].
 *
 * ### Construction
 * This JavaScript class, like most in my interface, cannot be constructed directly (i.e. `new
 * Expression()` is going to throw an error); instead, you must invoke the parser via the functions
 * in the exported [[Parser]] module.
 *
 * ### Evaluation
 * The language accepted by this parser allows for "sub-expressions" — runs of code that may remain
 * unevaluated, to be executed at a later point.
 *
 * The most direct method of interacting with these, is manually testing whether a particular method
 * has produced a [[Literal]] or a [[Sub]]-expression, and proceeding as appropriate:
 *
 * ```typescript
 * const expr = Parser.expressionOfString('(echo test_cmd) arg'),
 *    cmd = expr.command
 *
 * switch (cmd.type) {
 *    case 'literal': console.log(cmd.value) // ... use stringish val,
 *    case 'subexpression': handleSubexpr(cmd.expr) // or evaluate.
 * }
 * ```
 *
 * However, this can be tedious, if you only wish to evaluate simple expressions. For these
 * situations, I provide a simplified "recursive evaluation" interface: by inverting control, you
 * can allow the parser to become responsible for recursively evaluating [[Sub]] and [[Literal]]
 * values into simple `string`s, as long as you can provide the parser with a simplified
 * handler-callback that will attempt to reduce a single, given sub-expression into a `string`.
 *
 * The entry-point to this auto-evaluation interface is either [[cloneWithEvaluator]], or as a
 * further convenience, the various `eval*` methods below: [[evalCommand]], [[evalPositionals]], and
 * so on.
 *
 * Each of these takes a function — matching the [[evaluator]] signature — that takes an expression,
 * and mechanistically reduces it into a simple string:
 *
 * ```typescript
 * const expr = Parser.expressionOfString('(echo test_cmd) arg')
 *
 * function handleSubexpr(expr) {
 *    if (expr.command === 'echo') {
 *       return expr.positionals.join(' ')
 *    }
 * }
 *
 * console.log("Command:", expr.evalCommand(handleSubexpr))
 * //=> prints "Command: test_cmd"
 * ```
 *
 * (Note, additionally, that within the body of the evaluator above, I've only had to compare
 * `expr.command` to a string, directly. As evaluators receive [[ExpressionEval]]s instead of plain
 * expressions, their bodies need no further shenanigans; any requested expression-properties will
 * recursively evaluate further subexpressions as-needed.)
 *
 * Finally, if you want to access multiple elements of an expression thusly, it may be easier to
 * pre-associate an evaluator with the expression using [[cloneWithEvaluator]], producing an
 * [[ExpressionEval]] directly:
 *
 * ```typescript
 * function handleSubexpr(expr) {
 *    if (expr.command === 'echo') {
 *       return expr.positionals.join(' ')
 *    }
 * }
 *
 * const expr = Parser.expressionOfString('(echo test_cmd) arg'),
 *    ee = expr.cloneWithEvaluator(handleSubexpr)
 *
 * console.log(`Command: ${ee.command}, args: ${ee.positionals.join(' ')}`)
 * //=> prints "Command: test_cmd, args: arg"
 * ```
 *
 * ### Mutation
 * Importantly, these `Expression`s are *mutable* views onto the underlying AST. They're designed to
 * ensure you don't access the data-structure in an unsafe way. In particular, a given `word` in the
 * original input-string can only be *either* a flag-payload, *or* a positional argument — not both.
 *
 * Consider the following:
 *
 * ```typescript
 * const expr = Parser.expressionOfString('hello -f world')
 * ```
 *
 * Does that command have one flag, with the payload `world`? Or an empty (boolean) flag, and a
 * single positional-argument, `world`? My answer, in this interface, is “whichever you observe
 * first”. To be more specific, any method of either [[Expression]] or [[ExpressionEval]] that
 * produces flag-payloads or positional arguments, will *mutate* the data-structure such that
 * subsequent accesses don't see an inconsistent state.
 *
 * Let's look at some examples:
 *
 * ```typescript
 * const expr1 = Parser.expressionOfString('hello -f world')
 *
 * expr1.getFlag('f').value //=> returs 'world';
 * expr1.getPositionals() //=> returns []
 * ```
 *
 * Here, [[getFlag]] mutated `expr1`; and so a subsequent [[getPositionals]] produced a consistent
 * result: there were no remaining positional arguments.
 *
 * ```typescript
 * const expr2 = Parser.expressionOfString('hello -f world')
 *
 * expr2.getPositionals() //=> returns one arg, [{ value: 'world' }]
 * expr2.getFlag('f') //=> returs undefined; because `-f` has no payload
 * ```
 *
 * Here, [[getPositionals]] mutated `expr2`; and so a subsequent [[getFlag]], *again*, produced a
 * consistent result: there was no value available to become the payload of `-f`.
 *
 * This interface is intended to be used in a form wherein the invocations of these methods acts as
 * the specification of the parser's behaviour. For example, one command might expect a flag `-d` or
 * `--dest`, and demand a payload for that flag; whereas another might use `-d` as a boolean, and
 * expect positionals. This way, the behaviour of the parser is flexible enough to handle both of
 * those situations.
 *
 * Finally, note that at least for flags, there's also non-mutative accessors: you can always check
 * whether a flag *exists* using [[hasFlag]].
 */


var Expression =
/*#__PURE__*/
function (_ExpressionCommon) {
  (0, _inherits2["default"])(Expression, _ExpressionCommon);

  function Expression() {
    (0, _classCallCheck2["default"])(this, Expression);
    return (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(Expression).apply(this, arguments));
  }

  (0, _createClass2["default"])(Expression, [{
    key: "clone",
    value: function clone() {
      var $new = _aST["default"].copy_expression(this.$expr);

      return new Expression(INTERNAL, $new);
    }
  }, {
    key: "cloneWithEvaluator",
    value: function cloneWithEvaluator(handleSubexpr) {
      var $new = _aST["default"].copy_expression(this.$expr);

      return new ExpressionEval(INTERNAL, $new, handleSubexpr);
    }
  }, {
    key: "evalCommand",
    value: function evalCommand(handleSubexpr) {
      var ee = new ExpressionEval(INTERNAL, this.$expr, handleSubexpr);
      return ee.command;
    } // Wrapper for `Expression.positionals`

  }, {
    key: "getPositionals",
    value: function getPositionals() {
      var $positionals = _expression["default"].positionals_arr(this.$expr);

      return $positionals.map(fromOrSubexpr);
    }
  }, {
    key: "evalPositionals",
    value: function evalPositionals(handleSubexpr) {
      var ee = new ExpressionEval(INTERNAL, this.$expr, handleSubexpr);
      return ee.getPositionals();
    } // Wrapper for `Expression.iter`

  }, {
    key: "forEachFlag",
    value: function forEachFlag(f) {
      var flagMapper = function flagMapper(idx, $name, $payloadOpt) {
        var name = (0, _ocamlStringConvert.fromFakeUTF8String)($name),
            $payload = fromFlagPayloadOption($payloadOpt),
            payload = typeof $payload === 'undefined' ? undefined : fromOrSubexpr($payload);
        f.call(null, name, payload, idx);
      };

      _expression["default"].iteri(flagMapper, this.$expr);
    }
  }, {
    key: "evalEachFlag",
    value: function evalEachFlag(handleSubexpr, f) {
      var ee = new ExpressionEval(INTERNAL, this.$expr, handleSubexpr);
      return ee.forEachFlag(f);
    } // Wrapper for `Expression.flag`
    // TODO: Rename to something clearer, like getPayload

  }, {
    key: "getFlag",
    value: function getFlag(flag) {
      console.assert(typeof flag === 'string');

      var $flag = (0, _ocamlStringConvert.toFakeUTF8String)(flag),
          $payloadOpt = _expression["default"].flag($flag, this.$expr),
          $payload = fromFlagPayloadOption($payloadOpt);

      return typeof $payload === 'undefined' ? undefined : fromOrSubexpr($payload);
    }
  }, {
    key: "evalFlag",
    value: function evalFlag(handleSubexpr, flag) {
      var ee = new ExpressionEval(INTERNAL, this.$expr, handleSubexpr);
      return ee.getFlag(flag);
    }
  }, {
    key: "command",
    get: function get() {
      var $command = _expression["default"].command(this.$expr);

      return fromOrSubexpr($command);
    }
  }]);
  return Expression;
}(ExpressionCommon); // `Expression.t`, with recursive evaluation of subexpressions


exports.Expression = Expression;

var ExpressionEval =
/*#__PURE__*/
function (_ExpressionCommon2) {
  (0, _inherits2["default"])(ExpressionEval, _ExpressionCommon2);

  function ExpressionEval(isInternal, $expr, handleSubexpr) {
    var _this4;

    (0, _classCallCheck2["default"])(this, ExpressionEval);
    if (isInternal !== INTERNAL) throw new Error('`ExpressionEval` can only be constructed by `Expression#evalPositionals()` and similar.');
    _this4 = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(ExpressionEval).call(this, isInternal, $expr));
    console.assert(typeof handleSubexpr === 'function');
    _this4.evaluator = handleSubexpr;
    return _this4;
  }

  (0, _createClass2["default"])(ExpressionEval, [{
    key: "clone",
    value: function clone() {
      var $new = _aST["default"].copy_expression(this.$expr);

      return new ExpressionEval(INTERNAL, $new, this.evaluator);
    }
  }, {
    key: "getPositionals",
    // Wrapper for `Expression.positionals`
    value: function getPositionals() {
      var $positionals = _expression["default"].positionals_arr(this.$expr); // My kingdom for better functional tooling in JavaScript ;_;


      return $positionals.map(reduceOrSubexprWithEval.bind(null, this.evaluator));
    } // Wrapper for `Expression.iter`

  }, {
    key: "forEachFlag",
    value: function forEachFlag(f) {
      var self = this,
          flagMapper = function flagMapper(idx, $name, $payloadOpt) {
        var name = (0, _ocamlStringConvert.fromFakeUTF8String)($name),
            $payload = fromFlagPayloadOption($payloadOpt),
            payload = typeof $payload === 'undefined' ? undefined : reduceOrSubexprWithEval(self.evaluator, $payload);
        f.call(null, name, payload, idx);
      };

      _expression["default"].iteri(flagMapper, this.$expr);
    } // Wrapper for `Expression.flag`

  }, {
    key: "getFlag",
    value: function getFlag(flag) {
      console.assert(typeof flag === 'string');

      var $flag = (0, _ocamlStringConvert.toFakeUTF8String)(flag),
          $payloadOpt = _expression["default"].flag($flag, this.$expr),
          $payload = fromFlagPayloadOption($payloadOpt);

      return typeof $payload === 'undefined' ? undefined : reduceOrSubexprWithEval(this.evaluator, $payload);
    }
  }, {
    key: "command",
    get: function get() {
      var $command = _expression["default"].command(this.$expr);

      return reduceOrSubexprWithEval(this.evaluator, $command);
    }
  }]);
  return ExpressionEval;
}(ExpressionCommon);

exports.ExpressionEval = ExpressionEval;

var LexBuffer =
/*#__PURE__*/
function () {
  /** @hidden */
  function LexBuffer(isInternal, $buf) {
    (0, _classCallCheck2["default"])(this, LexBuffer);
    if (isInternal !== INTERNAL) throw new Error('`Buffer` must be constructed with `LexBuffer.ofString()` et al.');
    this.$buf = $buf;
  }

  (0, _createClass2["default"])(LexBuffer, [{
    key: "next",
    value: function next() {
      var $loctok = _lexer["default"].next_loc(this.$buf);

      return new LocatedToken(INTERNAL, $loctok);
    }
  }, {
    key: "rest",
    value: function rest() {
      return _lexer["default"].tokens_loc(this.$buf).map(function ($loctok) {
        return new LocatedToken(INTERNAL, $loctok);
      });
    }
  }], [{
    key: "ofString",
    value: function ofString(str) {
      console.assert(typeof str === 'string');

      var $utf8 = (0, _ocamlStringConvert.toFakeUTF8String)(str),
          $buf = _lexer["default"].buffer_of_string($utf8);

      return new LexBuffer(INTERNAL, $buf);
    }
  }]);
  return LexBuffer;
}();

exports.LexBuffer = LexBuffer;

var Position =
/*#__PURE__*/
function () {
  /** @hidden */
  function Position(isInternal, $pos) {
    (0, _classCallCheck2["default"])(this, Position);
    if (isInternal !== INTERNAL) throw new Error('`Position` cannot be constructed');
    this.$pos = $pos;
  }

  (0, _createClass2["default"])(Position, [{
    key: "filename",
    get: function get() {
      var $fname = _lexer["default"].position_fname(this.$pos);

      return (0, _ocamlStringConvert.fromFakeUTF8String)($fname);
    }
  }, {
    key: "line",
    get: function get() {
      return _lexer["default"].position_lnum(this.$pos);
    }
  }, {
    key: "byte",
    get: function get() {
      return _lexer["default"].position_cnum(this.$pos);
    }
  }, {
    key: "character",
    get: function get() {
      return _lexer["default"].position_bol(this.$pos);
    }
  }]);
  return Position;
}();

exports.Position = Position;

var LocatedToken =
/*#__PURE__*/
function () {
  /** @hidden */
  function LocatedToken(isInternal, $loctok) {
    (0, _classCallCheck2["default"])(this, LocatedToken);
    if (isInternal !== INTERNAL) throw new Error('`LocatedToken` cannot be constructed');
    this.$loctok = $loctok;
  }

  (0, _createClass2["default"])(LocatedToken, [{
    key: "$token",
    get: function get() {
      return _lexer["default"].token(this.$loctok);
    }
  }, {
    key: "token",
    get: function get() {
      return new Token(INTERNAL, this.$token);
    }
  }, {
    key: "id",
    get: function get() {
      return Symbol["for"](_lexer["default"].show_token(this.$token));
    }
  }, {
    key: "startLine",
    get: function get() {
      return _lexer["default"].start_lnum(this.$loctok);
    }
  }, {
    key: "startIdx",
    get: function get() {
      return _lexer["default"].start_cnum(this.$loctok);
    }
  }, {
    key: "endLine",
    get: function get() {
      return _lexer["default"].end_lnum(this.$loctok);
    }
  }, {
    key: "endIdx",
    get: function get() {
      return _lexer["default"].end_cnum(this.$loctok);
    }
  }, {
    key: "body",
    get: function get() {
      return new Token(INTERNAL, this.$token).body;
    }
  }]);
  return LocatedToken;
}();

exports.LocatedToken = LocatedToken;

var Token =
/*#__PURE__*/
function () {
  /** @hidden */
  function Token(isInternal, $tok) {
    (0, _classCallCheck2["default"])(this, Token);
    if (isInternal !== INTERNAL) throw new Error('`Token` cannot be constructed');
    this.$token = $tok;
  }

  (0, _createClass2["default"])(Token, [{
    key: "compare",
    value: function compare(other) {
      console.assert(other instanceof Token);
      return _lexer["default"].compare_token(this.$token, other.$token);
    }
  }, {
    key: "id",
    get: function get() {
      return Symbol["for"](_lexer["default"].show_token(this.$token));
    }
  }, {
    key: "body",
    get: function get() {
      var $body = _lexer["default"].token_body(this.$token);

      return fromFakeUTF8StringOption($body);
    }
  }]);
  return Token;
}();
/** @hidden */


exports.Token = Token;

// Wrapper for Incremental.checkpoint.
var Checkpoint =
/*#__PURE__*/
function () {
  /** @hidden */
  function Checkpoint(isInternal, $cp, type) {
    (0, _classCallCheck2["default"])(this, Checkpoint);
    if (isInternal !== INTERNAL) throw new Error('`Checkpoint` can only be constructed by `Excmd.startScript()` and friends.');
    this.$cp = $cp;
    this.type = type;
  }
  /** @hidden */


  (0, _createClass2["default"])(Checkpoint, [{
    key: "producesScript",
    value: function producesScript() {
      return this.type === 'script';
    }
    /** @hidden */

  }, {
    key: "producesExpression",
    value: function producesExpression() {
      return this.type === 'expression';
    }
  }, {
    key: "continue",
    value: function _continue() {
      var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var self = this;
      var acceptMapper;
      if (typeof opts.onAccept === 'undefined') acceptMapper = function acceptMapper() {};else if (this.producesScript()) acceptMapper = function wrapScript($scpt) {
        var scpt = new Script(INTERNAL, $scpt),
            onAccept = opts.onAccept;
        return onAccept(scpt);
      };else acceptMapper = function wrapExpression($expr) {
        var expr = new Expression(INTERNAL, $expr),
            onAccept = opts.onAccept;
        return onAccept(expr);
      };
      var onFail = opts.onFail;
      var failMapper;
      if (typeof onFail === 'undefined') failMapper = function failMapper() {};else failMapper = function failMapper($lastGood, $errorAt) {
        var lastGood = new Checkpoint(INTERNAL, $lastGood, self.type),
            errorAt = new Checkpoint(INTERNAL, $errorAt, self.type);
        return onFail(lastGood, errorAt);
      }; // (BuckleScript mangles `continue` due to that being a reserved word in JavaScript.)

      return _incremental["default"].$$continue(acceptMapper, failMapper, this.$cp);
    } // FIXME: This, and some of these others, have constraints on the *state* of the checkpoint
    //        before they make sense (i.e. 'this must be in the InputNeeded state' or similar.) I'd
    //        like to raise the errors on the JavaScript side, in a JavaScript-friendly way, with
    //        the option of returning an optional instead of allowing for runtime exceptions ...

  }, {
    key: "acceptable_token",
    get: function get() {
      var $tok = _incremental["default"].acceptable_token(this.$cp);

      return new Token(INTERNAL, $tok);
    }
  }, {
    key: "acceptable_tokens",
    get: function get() {
      var $toks = _incremental["default"].acceptable_tokens(this.$cp);

      return $toks.map(function ($tok) {
        return new Token(INTERNAL, $tok);
      });
    }
  }, {
    key: "command",
    get: function get() {
      var $command = _incremental["default"].current_command(this.$cp);

      return typeof $command === 'undefined' ? undefined : fromOrSubexpr($command);
    } // FIXME: More accessors

  }, {
    key: "automaton_status",
    get: function get() {
      return _incremental["default"].automaton_status_str(this.$cp);
    }
  }, {
    key: "incoming_symbol_category",
    get: function get() {
      return _incremental["default"].incoming_symbol_category_str(this.$cp);
    }
  }, {
    key: "incoming_symbol_type",
    get: function get() {
      return _incremental["default"].incoming_symbol_type_str(this.$cp);
    }
  }, {
    key: "incoming_symbol",
    get: function get() {
      return _incremental["default"].incoming_symbol_str(this.$cp);
    }
  }, {
    key: "beforeStack",
    get: function get() {
      return new AutomatonStack(INTERNAL, this, false);
    }
  }, {
    key: "afterStack",
    get: function get() {
      return new AutomatonStack(INTERNAL, this, true);
    }
  }]);
  return Checkpoint;
}();

exports.Checkpoint = Checkpoint;

var AutomatonStack =
/*#__PURE__*/
function () {
  function AutomatonStack(isInternal, cp, isAfterStack) {
    (0, _classCallCheck2["default"])(this, AutomatonStack);
    if (isInternal !== INTERNAL) throw new Error('`AutomatonStack` can only be obtained via `Checkpoint::beforeStack()` and friends.');
    this.cp = cp;
    this.isAfterStack = isAfterStack;
  }

  (0, _createClass2["default"])(AutomatonStack, [{
    key: Symbol.iterator,
    value:
    /*#__PURE__*/
    _regenerator["default"].mark(function value() {
      var $cp, $get, $el, _idx;

      return _regenerator["default"].wrap(function value$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              $cp = this.cp.$cp;
              $get = this.isAfterStack ? _incremental["default"].get_after : _incremental["default"].get_before; // Translated, "while get_whichever() isn't None." Yeah, it's a mess.

              _idx = 0;

            case 3:
              if (!($el = $get($cp, _idx))) {
                _context.next = 9;
                break;
              }

              _context.next = 6;
              return new AutomatonElement(INTERNAL, $el);

            case 6:
              _idx++;
              _context.next = 3;
              break;

            case 9:
            case "end":
              return _context.stop();
          }
        }
      }, value, this);
    })
  }]);
  return AutomatonStack;
}();

exports.AutomatonStack = AutomatonStack;

var AutomatonElement =
/*#__PURE__*/
function () {
  /** @hidden */
  function AutomatonElement(isInternal, $el) {
    (0, _classCallCheck2["default"])(this, AutomatonElement);
    if (isInternal !== INTERNAL) throw new Error('`AutomatonElement` can only be obtained by iterating over `Checkpoint::stackBefore()` and friends.');
    this.$el = $el;
  }

  (0, _createClass2["default"])(AutomatonElement, [{
    key: "incoming_symbol_category",
    get: function get() {
      return _incremental["default"].element_incoming_symbol_category_str(this.$el);
    }
  }, {
    key: "incoming_symbol_type",
    get: function get() {
      return _incremental["default"].element_incoming_symbol_type_str(this.$el);
    }
  }, {
    key: "incoming_symbol",
    get: function get() {
      return _incremental["default"].element_incoming_symbol_str(this.$el);
    }
  }]);
  return AutomatonElement;
}();

exports.AutomatonElement = AutomatonElement;
var _default = {
  OCamlError: OCamlError,
  LexError: LexError,
  Parser: Parser,
  Script: Script,
  Expression: Expression,
  LexBuffer: LexBuffer,
  LocatedToken: LocatedToken,
  Token: Token,
  Checkpoint: Checkpoint
};
exports["default"] = _default;