
(* The type of tokens. *)

type token = 
  | URL_START of (string)
  | URL_REST of (string)
  | SEMICOLON
  | QUOTE_OPEN of (string)
  | QUOTE_ESCAPE of (string)
  | QUOTE_CLOSE of (string)
  | QUOTE_CHUNK of (string)
  | PIPE
  | PAREN_OPEN
  | PAREN_CLOSE
  | IDENTIFIER of (string)
  | FLAG_LONG_START
  | FLAGS_SHORT_START
  | ERR_UNEXPECTED_WHITESPACE of (string)
  | ERR_UNEXPECTED_QUOTE_ESCAPE of (string * string)
  | ERR_UNEXPECTED_QUOTE_CLOSE of (string * string)
  | ERR_UNEXPECTED_COMMENT_CLOSE of (string)
  | ERR_UNEXPECTED_CHARACTER of (int * string)
  | ERR_MISSING_DELIM_CLOSE of (string * string)
  | ERR_MISSING_COMMENT_CLOSE of (string)
  | EQUALS
  | EOF
  | COUNT of (string)
  | COMMENT_OPEN
  | COMMENT_CLOSE
  | COMMENT of (string)
  | COLON
  | BARE_DOUBLE_DASH

(* The indexed type of terminal symbols. *)

type _ terminal = 
  | T_error : unit terminal
  | T_URL_START : (string) terminal
  | T_URL_REST : (string) terminal
  | T_SEMICOLON : unit terminal
  | T_QUOTE_OPEN : (string) terminal
  | T_QUOTE_ESCAPE : (string) terminal
  | T_QUOTE_CLOSE : (string) terminal
  | T_QUOTE_CHUNK : (string) terminal
  | T_PIPE : unit terminal
  | T_PAREN_OPEN : unit terminal
  | T_PAREN_CLOSE : unit terminal
  | T_IDENTIFIER : (string) terminal
  | T_FLAG_LONG_START : unit terminal
  | T_FLAGS_SHORT_START : unit terminal
  | T_ERR_UNEXPECTED_WHITESPACE : (string) terminal
  | T_ERR_UNEXPECTED_QUOTE_ESCAPE : (string * string) terminal
  | T_ERR_UNEXPECTED_QUOTE_CLOSE : (string * string) terminal
  | T_ERR_UNEXPECTED_COMMENT_CLOSE : (string) terminal
  | T_ERR_UNEXPECTED_CHARACTER : (int * string) terminal
  | T_ERR_MISSING_DELIM_CLOSE : (string * string) terminal
  | T_ERR_MISSING_COMMENT_CLOSE : (string) terminal
  | T_EQUALS : unit terminal
  | T_EOF : unit terminal
  | T_COUNT : (string) terminal
  | T_COMMENT_OPEN : unit terminal
  | T_COMMENT_CLOSE : unit terminal
  | T_COMMENT : (string) terminal
  | T_COLON : unit terminal
  | T_BARE_DOUBLE_DASH : unit terminal
