'use strict';

var AST = require("./aST.bs.js");
var Gen = require("bs-gen/src/gen.bs.js");
var List = require("bs-platform/lib/js/list.js");
var $$Array = require("bs-platform/lib/js/array.js");
var Curry = require("bs-platform/lib/js/curry.js");
var Pervasives = require("bs-platform/lib/js/pervasives.js");

function hydrate(expr) {
  return expr;
}

function dehydrate(expr) {
  return expr;
}

function from_script(scpt) {
  return scpt[/* expressions */0];
}

var pp = AST.pp_expression;

function count(expr) {
  return expr[/* count */0];
}

function command(expr) {
  return expr[/* cmd */1];
}

function payload_to_opt(param) {
  if (param) {
    return param[0];
  }
  
}

function mem(key, expr) {
  var is_matching_key = function (param) {
    if (param.tag) {
      return param[0][/* name */0] === key;
    } else {
      return false;
    }
  };
  return List.exists(is_matching_key, expr[/* rev_args */2]);
}

function is_resolved(key, expr) {
  var is_matching_resolved_key = function (param) {
    if (param.tag) {
      var f = param[0];
      if (f[/* name */0] !== key) {
        return false;
      } else {
        var match = f[/* payload */1];
        if (typeof match === "number") {
          return match !== 0;
        } else {
          return true;
        }
      }
    } else {
      return false;
    }
  };
  return List.exists(is_matching_resolved_key, expr[/* rev_args */2]);
}

function has_payload(key, expr) {
  var is_matching_resolved_key_with_payload = function (param) {
    if (param.tag) {
      var f = param[0];
      if (f[/* name */0] !== key) {
        return false;
      } else {
        var match = f[/* payload */1];
        if (typeof match === "number") {
          return false;
        } else {
          return true;
        }
      }
    } else {
      return false;
    }
  };
  return List.exists(is_matching_resolved_key_with_payload, expr[/* rev_args */2]);
}

function flag(key, expr) {
  var result = /* record */[/* contents */undefined];
  var iterator = function (param) {
    var prior = param[1];
    var curr = param[0];
    var match = result[0];
    if (match !== undefined) {
      return curr;
    } else if (prior !== undefined) {
      var prior$1 = prior;
      var fl;
      var exit = 0;
      if (prior$1.tag) {
        var fl$1 = prior$1[0];
        var match$1 = fl$1[/* payload */1];
        if (typeof match$1 === "number") {
          if (match$1 !== 0) {
            if (curr.tag) {
              exit = 2;
            } else {
              return curr;
            }
          } else if (curr.tag) {
            exit = 2;
          } else if (key === fl$1[/* name */0]) {
            fl$1[/* payload */1] = /* Resolved */[curr[0]];
            result[0] = fl$1;
            return ;
          } else {
            return curr;
          }
        } else if (curr.tag) {
          exit = 2;
        } else {
          return curr;
        }
      } else if (curr.tag) {
        exit = 2;
      } else {
        return curr;
      }
      if (exit === 2) {
        var fl$2 = curr[0];
        var match$2 = fl$2[/* payload */1];
        if (typeof match$2 === "number" && match$2 === 0) {
          return curr;
        } else {
          fl = fl$2;
        }
      }
      if (key === fl[/* name */0]) {
        result[0] = fl;
      }
      return curr;
    } else if (curr.tag) {
      var fl$3 = curr[0];
      if (key === fl$3[/* name */0]) {
        result[0] = fl$3;
      }
      return curr;
    } else {
      return curr;
    }
  };
  expr[/* rev_args */2] = Gen.to_list(Gen.filter_map(iterator, Gen.peek(Gen.of_list(expr[/* rev_args */2]))));
  var match = result[0];
  if (match !== undefined) {
    var match$1 = match[/* payload */1];
    if (typeof match$1 === "number") {
      if (match$1 !== 0) {
        return /* Empty */0;
      } else {
        return Pervasives.failwith("Unreachable");
      }
    } else {
      return /* Payload */[match$1[0]];
    }
  }
  
}

function flag_resolving_gen(expr) {
  var iterator = function (param) {
    var prior = param[1];
    var curr = param[0];
    if (prior !== undefined) {
      var match = prior;
      if (match.tag && !curr.tag) {
        match[0][/* payload */1] = /* Resolved */[curr[0]];
        return ;
      } else {
        return curr;
      }
    } else {
      return curr;
    }
  };
  return Gen.filter_map(iterator, Gen.peek(Gen.of_list(expr[/* rev_args */2])));
}

function rev_iteri(f, expr) {
  var iterator = function (i, arg) {
    if (arg.tag) {
      var flag = arg[0];
      var match = flag[/* payload */1];
      if (typeof match === "number") {
        if (match !== 0) {
          Curry._3(f, i, flag[/* name */0], /* Empty */0);
          return arg;
        } else {
          return Pervasives.failwith("Unreachable");
        }
      } else {
        Curry._3(f, i, flag[/* name */0], /* Payload */[match[0]]);
        return arg;
      }
    } else {
      return arg;
    }
  };
  expr[/* rev_args */2] = Gen.to_list(Gen.mapi(iterator)(flag_resolving_gen(expr)));
  return /* () */0;
}

function iteri(f, expr) {
  expr[/* rev_args */2] = Gen.to_list(flag_resolving_gen(expr));
  var iterator = function (i, param) {
    if (param.tag) {
      var flag = param[0];
      var match = flag[/* payload */1];
      if (typeof match === "number") {
        if (match !== 0) {
          return Curry._3(f, i, flag[/* name */0], /* Empty */0);
        } else {
          return Pervasives.failwith("Unreachable");
        }
      } else {
        return Curry._3(f, i, flag[/* name */0], /* Payload */[match[0]]);
      }
    } else {
      return /* () */0;
    }
  };
  return List.iteri(iterator, List.rev(expr[/* rev_args */2]));
}

function iter(f, expr) {
  var f$1 = function (_i, a, b) {
    return Curry._2(f, a, b);
  };
  return iteri(f$1, expr);
}

function positionals(expr) {
  var iterator = function (param) {
    if (param.tag) {
      var flag = param[0];
      var match = flag[/* payload */1];
      if (typeof match === "number" && match === 0) {
        flag[/* payload */1] = /* Absent */1;
        return ;
      } else {
        return ;
      }
    } else {
      return param[0];
    }
  };
  return Gen.to_rev_list(Gen.filter_map(iterator, Gen.of_list(expr[/* rev_args */2])));
}

function positionals_arr(expr) {
  return $$Array.of_list(positionals(expr));
}

function flags(expr) {
  var iterator = function (param) {
    if (param.tag) {
      return param[0][/* name */0];
    }
    
  };
  return Gen.to_rev_list(Gen.filter_map(iterator, Gen.of_list(expr[/* rev_args */2])));
}

function flags_arr(expr) {
  return $$Array.of_list(flags(expr));
}

exports.count = count;
exports.command = command;
exports.mem = mem;
exports.is_resolved = is_resolved;
exports.has_payload = has_payload;
exports.flags = flags;
exports.positionals = positionals;
exports.iter = iter;
exports.iteri = iteri;
exports.rev_iteri = rev_iteri;
exports.flag = flag;
exports.pp = pp;
exports.hydrate = hydrate;
exports.from_script = from_script;
exports.payload_to_opt = payload_to_opt;
exports.flags_arr = flags_arr;
exports.positionals_arr = positionals_arr;
exports.dehydrate = dehydrate;
/* AST Not a pure module */
