'use strict';

var Block = require("bs-platform/lib/js/block.js");
var Curry = require("bs-platform/lib/js/curry.js");
var Ppx_deriving_runtime = require("bs-deriving/src/runtime/ppx_deriving_runtime.bs.js");

function pp_token(fmt, param) {
  if (typeof param === "number") {
    switch (param) {
      case /* SEMICOLON */0 :
          return Curry._2(Ppx_deriving_runtime.Format.pp_print_string, fmt, "SEMICOLON");
      case /* PIPE */1 :
          return Curry._2(Ppx_deriving_runtime.Format.pp_print_string, fmt, "PIPE");
      case /* PAREN_OPEN */2 :
          return Curry._2(Ppx_deriving_runtime.Format.pp_print_string, fmt, "PAREN_OPEN");
      case /* PAREN_CLOSE */3 :
          return Curry._2(Ppx_deriving_runtime.Format.pp_print_string, fmt, "PAREN_CLOSE");
      case /* FLAG_LONG_START */4 :
          return Curry._2(Ppx_deriving_runtime.Format.pp_print_string, fmt, "FLAG_LONG_START");
      case /* FLAGS_SHORT_START */5 :
          return Curry._2(Ppx_deriving_runtime.Format.pp_print_string, fmt, "FLAGS_SHORT_START");
      case /* EQUALS */6 :
          return Curry._2(Ppx_deriving_runtime.Format.pp_print_string, fmt, "EQUALS");
      case /* EOF */7 :
          return Curry._2(Ppx_deriving_runtime.Format.pp_print_string, fmt, "EOF");
      case /* COMMENT_OPEN */8 :
          return Curry._2(Ppx_deriving_runtime.Format.pp_print_string, fmt, "COMMENT_OPEN");
      case /* COMMENT_CLOSE */9 :
          return Curry._2(Ppx_deriving_runtime.Format.pp_print_string, fmt, "COMMENT_CLOSE");
      case /* COLON */10 :
          return Curry._2(Ppx_deriving_runtime.Format.pp_print_string, fmt, "COLON");
      case /* BARE_DOUBLE_DASH */11 :
          return Curry._2(Ppx_deriving_runtime.Format.pp_print_string, fmt, "BARE_DOUBLE_DASH");
      
    }
  } else {
    switch (param.tag | 0) {
      case /* URL_START */0 :
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "(" */40,
                    /* Formatting_gen */Block.__(18, [
                        /* Open_box */Block.__(1, [/* Format */[
                              /* String_literal */Block.__(11, [
                                  "<2>",
                                  /* End_of_format */0
                                ]),
                              "<2>"
                            ]]),
                        /* String_literal */Block.__(11, [
                            "URL_START",
                            /* Formatting_lit */Block.__(17, [
                                /* Break */Block.__(0, [
                                    "@ ",
                                    1,
                                    0
                                  ]),
                                /* End_of_format */0
                              ])
                          ])
                      ])
                  ]),
                "(@[<2>URL_START@ "
              ]);
          Curry._3(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Caml_string */Block.__(3, [
                    /* No_padding */0,
                    /* End_of_format */0
                  ]),
                "%S"
              ], param[0]);
          return Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                      /* Formatting_lit */Block.__(17, [
                          /* Close_box */0,
                          /* Char_literal */Block.__(12, [
                              /* ")" */41,
                              /* End_of_format */0
                            ])
                        ]),
                      "@])"
                    ]);
      case /* URL_REST */1 :
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "(" */40,
                    /* Formatting_gen */Block.__(18, [
                        /* Open_box */Block.__(1, [/* Format */[
                              /* String_literal */Block.__(11, [
                                  "<2>",
                                  /* End_of_format */0
                                ]),
                              "<2>"
                            ]]),
                        /* String_literal */Block.__(11, [
                            "URL_REST",
                            /* Formatting_lit */Block.__(17, [
                                /* Break */Block.__(0, [
                                    "@ ",
                                    1,
                                    0
                                  ]),
                                /* End_of_format */0
                              ])
                          ])
                      ])
                  ]),
                "(@[<2>URL_REST@ "
              ]);
          Curry._3(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Caml_string */Block.__(3, [
                    /* No_padding */0,
                    /* End_of_format */0
                  ]),
                "%S"
              ], param[0]);
          return Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                      /* Formatting_lit */Block.__(17, [
                          /* Close_box */0,
                          /* Char_literal */Block.__(12, [
                              /* ")" */41,
                              /* End_of_format */0
                            ])
                        ]),
                      "@])"
                    ]);
      case /* QUOTE_OPEN */2 :
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "(" */40,
                    /* Formatting_gen */Block.__(18, [
                        /* Open_box */Block.__(1, [/* Format */[
                              /* String_literal */Block.__(11, [
                                  "<2>",
                                  /* End_of_format */0
                                ]),
                              "<2>"
                            ]]),
                        /* String_literal */Block.__(11, [
                            "QUOTE_OPEN",
                            /* Formatting_lit */Block.__(17, [
                                /* Break */Block.__(0, [
                                    "@ ",
                                    1,
                                    0
                                  ]),
                                /* End_of_format */0
                              ])
                          ])
                      ])
                  ]),
                "(@[<2>QUOTE_OPEN@ "
              ]);
          Curry._3(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Caml_string */Block.__(3, [
                    /* No_padding */0,
                    /* End_of_format */0
                  ]),
                "%S"
              ], param[0]);
          return Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                      /* Formatting_lit */Block.__(17, [
                          /* Close_box */0,
                          /* Char_literal */Block.__(12, [
                              /* ")" */41,
                              /* End_of_format */0
                            ])
                        ]),
                      "@])"
                    ]);
      case /* QUOTE_ESCAPE */3 :
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "(" */40,
                    /* Formatting_gen */Block.__(18, [
                        /* Open_box */Block.__(1, [/* Format */[
                              /* String_literal */Block.__(11, [
                                  "<2>",
                                  /* End_of_format */0
                                ]),
                              "<2>"
                            ]]),
                        /* String_literal */Block.__(11, [
                            "QUOTE_ESCAPE",
                            /* Formatting_lit */Block.__(17, [
                                /* Break */Block.__(0, [
                                    "@ ",
                                    1,
                                    0
                                  ]),
                                /* End_of_format */0
                              ])
                          ])
                      ])
                  ]),
                "(@[<2>QUOTE_ESCAPE@ "
              ]);
          Curry._3(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Caml_string */Block.__(3, [
                    /* No_padding */0,
                    /* End_of_format */0
                  ]),
                "%S"
              ], param[0]);
          return Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                      /* Formatting_lit */Block.__(17, [
                          /* Close_box */0,
                          /* Char_literal */Block.__(12, [
                              /* ")" */41,
                              /* End_of_format */0
                            ])
                        ]),
                      "@])"
                    ]);
      case /* QUOTE_CLOSE */4 :
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "(" */40,
                    /* Formatting_gen */Block.__(18, [
                        /* Open_box */Block.__(1, [/* Format */[
                              /* String_literal */Block.__(11, [
                                  "<2>",
                                  /* End_of_format */0
                                ]),
                              "<2>"
                            ]]),
                        /* String_literal */Block.__(11, [
                            "QUOTE_CLOSE",
                            /* Formatting_lit */Block.__(17, [
                                /* Break */Block.__(0, [
                                    "@ ",
                                    1,
                                    0
                                  ]),
                                /* End_of_format */0
                              ])
                          ])
                      ])
                  ]),
                "(@[<2>QUOTE_CLOSE@ "
              ]);
          Curry._3(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Caml_string */Block.__(3, [
                    /* No_padding */0,
                    /* End_of_format */0
                  ]),
                "%S"
              ], param[0]);
          return Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                      /* Formatting_lit */Block.__(17, [
                          /* Close_box */0,
                          /* Char_literal */Block.__(12, [
                              /* ")" */41,
                              /* End_of_format */0
                            ])
                        ]),
                      "@])"
                    ]);
      case /* QUOTE_CHUNK */5 :
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "(" */40,
                    /* Formatting_gen */Block.__(18, [
                        /* Open_box */Block.__(1, [/* Format */[
                              /* String_literal */Block.__(11, [
                                  "<2>",
                                  /* End_of_format */0
                                ]),
                              "<2>"
                            ]]),
                        /* String_literal */Block.__(11, [
                            "QUOTE_CHUNK",
                            /* Formatting_lit */Block.__(17, [
                                /* Break */Block.__(0, [
                                    "@ ",
                                    1,
                                    0
                                  ]),
                                /* End_of_format */0
                              ])
                          ])
                      ])
                  ]),
                "(@[<2>QUOTE_CHUNK@ "
              ]);
          Curry._3(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Caml_string */Block.__(3, [
                    /* No_padding */0,
                    /* End_of_format */0
                  ]),
                "%S"
              ], param[0]);
          return Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                      /* Formatting_lit */Block.__(17, [
                          /* Close_box */0,
                          /* Char_literal */Block.__(12, [
                              /* ")" */41,
                              /* End_of_format */0
                            ])
                        ]),
                      "@])"
                    ]);
      case /* IDENTIFIER */6 :
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "(" */40,
                    /* Formatting_gen */Block.__(18, [
                        /* Open_box */Block.__(1, [/* Format */[
                              /* String_literal */Block.__(11, [
                                  "<2>",
                                  /* End_of_format */0
                                ]),
                              "<2>"
                            ]]),
                        /* String_literal */Block.__(11, [
                            "IDENTIFIER",
                            /* Formatting_lit */Block.__(17, [
                                /* Break */Block.__(0, [
                                    "@ ",
                                    1,
                                    0
                                  ]),
                                /* End_of_format */0
                              ])
                          ])
                      ])
                  ]),
                "(@[<2>IDENTIFIER@ "
              ]);
          Curry._3(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Caml_string */Block.__(3, [
                    /* No_padding */0,
                    /* End_of_format */0
                  ]),
                "%S"
              ], param[0]);
          return Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                      /* Formatting_lit */Block.__(17, [
                          /* Close_box */0,
                          /* Char_literal */Block.__(12, [
                              /* ")" */41,
                              /* End_of_format */0
                            ])
                        ]),
                      "@])"
                    ]);
      case /* ERR_UNEXPECTED_WHITESPACE */7 :
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "(" */40,
                    /* Formatting_gen */Block.__(18, [
                        /* Open_box */Block.__(1, [/* Format */[
                              /* String_literal */Block.__(11, [
                                  "<2>",
                                  /* End_of_format */0
                                ]),
                              "<2>"
                            ]]),
                        /* String_literal */Block.__(11, [
                            "ERR_UNEXPECTED_WHITESPACE",
                            /* Formatting_lit */Block.__(17, [
                                /* Break */Block.__(0, [
                                    "@ ",
                                    1,
                                    0
                                  ]),
                                /* End_of_format */0
                              ])
                          ])
                      ])
                  ]),
                "(@[<2>ERR_UNEXPECTED_WHITESPACE@ "
              ]);
          Curry._3(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Caml_string */Block.__(3, [
                    /* No_padding */0,
                    /* End_of_format */0
                  ]),
                "%S"
              ], param[0]);
          return Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                      /* Formatting_lit */Block.__(17, [
                          /* Close_box */0,
                          /* Char_literal */Block.__(12, [
                              /* ")" */41,
                              /* End_of_format */0
                            ])
                        ]),
                      "@])"
                    ]);
      case /* ERR_UNEXPECTED_QUOTE_ESCAPE */8 :
          var a0 = param[0];
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "(" */40,
                    /* Formatting_gen */Block.__(18, [
                        /* Open_box */Block.__(1, [/* Format */[
                              /* String_literal */Block.__(11, [
                                  "<2>",
                                  /* End_of_format */0
                                ]),
                              "<2>"
                            ]]),
                        /* String_literal */Block.__(11, [
                            "ERR_UNEXPECTED_QUOTE_ESCAPE",
                            /* Formatting_lit */Block.__(17, [
                                /* Break */Block.__(0, [
                                    "@ ",
                                    1,
                                    0
                                  ]),
                                /* End_of_format */0
                              ])
                          ])
                      ])
                  ]),
                "(@[<2>ERR_UNEXPECTED_QUOTE_ESCAPE@ "
              ]);
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "(" */40,
                    /* Formatting_gen */Block.__(18, [
                        /* Open_box */Block.__(1, [/* Format */[
                              /* End_of_format */0,
                              ""
                            ]]),
                        /* End_of_format */0
                      ])
                  ]),
                "(@["
              ]);
          Curry._3(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Caml_string */Block.__(3, [
                    /* No_padding */0,
                    /* End_of_format */0
                  ]),
                "%S"
              ], a0[0]);
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "," */44,
                    /* Formatting_lit */Block.__(17, [
                        /* Break */Block.__(0, [
                            "@ ",
                            1,
                            0
                          ]),
                        /* End_of_format */0
                      ])
                  ]),
                ",@ "
              ]);
          Curry._3(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Caml_string */Block.__(3, [
                    /* No_padding */0,
                    /* End_of_format */0
                  ]),
                "%S"
              ], a0[1]);
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Formatting_lit */Block.__(17, [
                    /* Close_box */0,
                    /* Char_literal */Block.__(12, [
                        /* ")" */41,
                        /* End_of_format */0
                      ])
                  ]),
                "@])"
              ]);
          return Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                      /* Formatting_lit */Block.__(17, [
                          /* Close_box */0,
                          /* Char_literal */Block.__(12, [
                              /* ")" */41,
                              /* End_of_format */0
                            ])
                        ]),
                      "@])"
                    ]);
      case /* ERR_UNEXPECTED_QUOTE_CLOSE */9 :
          var a0$1 = param[0];
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "(" */40,
                    /* Formatting_gen */Block.__(18, [
                        /* Open_box */Block.__(1, [/* Format */[
                              /* String_literal */Block.__(11, [
                                  "<2>",
                                  /* End_of_format */0
                                ]),
                              "<2>"
                            ]]),
                        /* String_literal */Block.__(11, [
                            "ERR_UNEXPECTED_QUOTE_CLOSE",
                            /* Formatting_lit */Block.__(17, [
                                /* Break */Block.__(0, [
                                    "@ ",
                                    1,
                                    0
                                  ]),
                                /* End_of_format */0
                              ])
                          ])
                      ])
                  ]),
                "(@[<2>ERR_UNEXPECTED_QUOTE_CLOSE@ "
              ]);
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "(" */40,
                    /* Formatting_gen */Block.__(18, [
                        /* Open_box */Block.__(1, [/* Format */[
                              /* End_of_format */0,
                              ""
                            ]]),
                        /* End_of_format */0
                      ])
                  ]),
                "(@["
              ]);
          Curry._3(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Caml_string */Block.__(3, [
                    /* No_padding */0,
                    /* End_of_format */0
                  ]),
                "%S"
              ], a0$1[0]);
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "," */44,
                    /* Formatting_lit */Block.__(17, [
                        /* Break */Block.__(0, [
                            "@ ",
                            1,
                            0
                          ]),
                        /* End_of_format */0
                      ])
                  ]),
                ",@ "
              ]);
          Curry._3(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Caml_string */Block.__(3, [
                    /* No_padding */0,
                    /* End_of_format */0
                  ]),
                "%S"
              ], a0$1[1]);
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Formatting_lit */Block.__(17, [
                    /* Close_box */0,
                    /* Char_literal */Block.__(12, [
                        /* ")" */41,
                        /* End_of_format */0
                      ])
                  ]),
                "@])"
              ]);
          return Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                      /* Formatting_lit */Block.__(17, [
                          /* Close_box */0,
                          /* Char_literal */Block.__(12, [
                              /* ")" */41,
                              /* End_of_format */0
                            ])
                        ]),
                      "@])"
                    ]);
      case /* ERR_UNEXPECTED_COMMENT_CLOSE */10 :
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "(" */40,
                    /* Formatting_gen */Block.__(18, [
                        /* Open_box */Block.__(1, [/* Format */[
                              /* String_literal */Block.__(11, [
                                  "<2>",
                                  /* End_of_format */0
                                ]),
                              "<2>"
                            ]]),
                        /* String_literal */Block.__(11, [
                            "ERR_UNEXPECTED_COMMENT_CLOSE",
                            /* Formatting_lit */Block.__(17, [
                                /* Break */Block.__(0, [
                                    "@ ",
                                    1,
                                    0
                                  ]),
                                /* End_of_format */0
                              ])
                          ])
                      ])
                  ]),
                "(@[<2>ERR_UNEXPECTED_COMMENT_CLOSE@ "
              ]);
          Curry._3(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Caml_string */Block.__(3, [
                    /* No_padding */0,
                    /* End_of_format */0
                  ]),
                "%S"
              ], param[0]);
          return Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                      /* Formatting_lit */Block.__(17, [
                          /* Close_box */0,
                          /* Char_literal */Block.__(12, [
                              /* ")" */41,
                              /* End_of_format */0
                            ])
                        ]),
                      "@])"
                    ]);
      case /* ERR_UNEXPECTED_CHARACTER */11 :
          var a0$2 = param[0];
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "(" */40,
                    /* Formatting_gen */Block.__(18, [
                        /* Open_box */Block.__(1, [/* Format */[
                              /* String_literal */Block.__(11, [
                                  "<2>",
                                  /* End_of_format */0
                                ]),
                              "<2>"
                            ]]),
                        /* String_literal */Block.__(11, [
                            "ERR_UNEXPECTED_CHARACTER",
                            /* Formatting_lit */Block.__(17, [
                                /* Break */Block.__(0, [
                                    "@ ",
                                    1,
                                    0
                                  ]),
                                /* End_of_format */0
                              ])
                          ])
                      ])
                  ]),
                "(@[<2>ERR_UNEXPECTED_CHARACTER@ "
              ]);
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "(" */40,
                    /* Formatting_gen */Block.__(18, [
                        /* Open_box */Block.__(1, [/* Format */[
                              /* End_of_format */0,
                              ""
                            ]]),
                        /* End_of_format */0
                      ])
                  ]),
                "(@["
              ]);
          Curry._3(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Int */Block.__(4, [
                    /* Int_d */0,
                    /* No_padding */0,
                    /* No_precision */0,
                    /* End_of_format */0
                  ]),
                "%d"
              ], a0$2[0]);
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "," */44,
                    /* Formatting_lit */Block.__(17, [
                        /* Break */Block.__(0, [
                            "@ ",
                            1,
                            0
                          ]),
                        /* End_of_format */0
                      ])
                  ]),
                ",@ "
              ]);
          Curry._3(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Caml_string */Block.__(3, [
                    /* No_padding */0,
                    /* End_of_format */0
                  ]),
                "%S"
              ], a0$2[1]);
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Formatting_lit */Block.__(17, [
                    /* Close_box */0,
                    /* Char_literal */Block.__(12, [
                        /* ")" */41,
                        /* End_of_format */0
                      ])
                  ]),
                "@])"
              ]);
          return Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                      /* Formatting_lit */Block.__(17, [
                          /* Close_box */0,
                          /* Char_literal */Block.__(12, [
                              /* ")" */41,
                              /* End_of_format */0
                            ])
                        ]),
                      "@])"
                    ]);
      case /* ERR_MISSING_DELIM_CLOSE */12 :
          var a0$3 = param[0];
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "(" */40,
                    /* Formatting_gen */Block.__(18, [
                        /* Open_box */Block.__(1, [/* Format */[
                              /* String_literal */Block.__(11, [
                                  "<2>",
                                  /* End_of_format */0
                                ]),
                              "<2>"
                            ]]),
                        /* String_literal */Block.__(11, [
                            "ERR_MISSING_DELIM_CLOSE",
                            /* Formatting_lit */Block.__(17, [
                                /* Break */Block.__(0, [
                                    "@ ",
                                    1,
                                    0
                                  ]),
                                /* End_of_format */0
                              ])
                          ])
                      ])
                  ]),
                "(@[<2>ERR_MISSING_DELIM_CLOSE@ "
              ]);
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "(" */40,
                    /* Formatting_gen */Block.__(18, [
                        /* Open_box */Block.__(1, [/* Format */[
                              /* End_of_format */0,
                              ""
                            ]]),
                        /* End_of_format */0
                      ])
                  ]),
                "(@["
              ]);
          Curry._3(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Caml_string */Block.__(3, [
                    /* No_padding */0,
                    /* End_of_format */0
                  ]),
                "%S"
              ], a0$3[0]);
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "," */44,
                    /* Formatting_lit */Block.__(17, [
                        /* Break */Block.__(0, [
                            "@ ",
                            1,
                            0
                          ]),
                        /* End_of_format */0
                      ])
                  ]),
                ",@ "
              ]);
          Curry._3(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Caml_string */Block.__(3, [
                    /* No_padding */0,
                    /* End_of_format */0
                  ]),
                "%S"
              ], a0$3[1]);
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Formatting_lit */Block.__(17, [
                    /* Close_box */0,
                    /* Char_literal */Block.__(12, [
                        /* ")" */41,
                        /* End_of_format */0
                      ])
                  ]),
                "@])"
              ]);
          return Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                      /* Formatting_lit */Block.__(17, [
                          /* Close_box */0,
                          /* Char_literal */Block.__(12, [
                              /* ")" */41,
                              /* End_of_format */0
                            ])
                        ]),
                      "@])"
                    ]);
      case /* ERR_MISSING_COMMENT_CLOSE */13 :
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "(" */40,
                    /* Formatting_gen */Block.__(18, [
                        /* Open_box */Block.__(1, [/* Format */[
                              /* String_literal */Block.__(11, [
                                  "<2>",
                                  /* End_of_format */0
                                ]),
                              "<2>"
                            ]]),
                        /* String_literal */Block.__(11, [
                            "ERR_MISSING_COMMENT_CLOSE",
                            /* Formatting_lit */Block.__(17, [
                                /* Break */Block.__(0, [
                                    "@ ",
                                    1,
                                    0
                                  ]),
                                /* End_of_format */0
                              ])
                          ])
                      ])
                  ]),
                "(@[<2>ERR_MISSING_COMMENT_CLOSE@ "
              ]);
          Curry._3(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Caml_string */Block.__(3, [
                    /* No_padding */0,
                    /* End_of_format */0
                  ]),
                "%S"
              ], param[0]);
          return Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                      /* Formatting_lit */Block.__(17, [
                          /* Close_box */0,
                          /* Char_literal */Block.__(12, [
                              /* ")" */41,
                              /* End_of_format */0
                            ])
                        ]),
                      "@])"
                    ]);
      case /* COUNT */14 :
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "(" */40,
                    /* Formatting_gen */Block.__(18, [
                        /* Open_box */Block.__(1, [/* Format */[
                              /* String_literal */Block.__(11, [
                                  "<2>",
                                  /* End_of_format */0
                                ]),
                              "<2>"
                            ]]),
                        /* String_literal */Block.__(11, [
                            "COUNT",
                            /* Formatting_lit */Block.__(17, [
                                /* Break */Block.__(0, [
                                    "@ ",
                                    1,
                                    0
                                  ]),
                                /* End_of_format */0
                              ])
                          ])
                      ])
                  ]),
                "(@[<2>COUNT@ "
              ]);
          Curry._3(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Caml_string */Block.__(3, [
                    /* No_padding */0,
                    /* End_of_format */0
                  ]),
                "%S"
              ], param[0]);
          return Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                      /* Formatting_lit */Block.__(17, [
                          /* Close_box */0,
                          /* Char_literal */Block.__(12, [
                              /* ")" */41,
                              /* End_of_format */0
                            ])
                        ]),
                      "@])"
                    ]);
      case /* COMMENT */15 :
          Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Char_literal */Block.__(12, [
                    /* "(" */40,
                    /* Formatting_gen */Block.__(18, [
                        /* Open_box */Block.__(1, [/* Format */[
                              /* String_literal */Block.__(11, [
                                  "<2>",
                                  /* End_of_format */0
                                ]),
                              "<2>"
                            ]]),
                        /* String_literal */Block.__(11, [
                            "COMMENT",
                            /* Formatting_lit */Block.__(17, [
                                /* Break */Block.__(0, [
                                    "@ ",
                                    1,
                                    0
                                  ]),
                                /* End_of_format */0
                              ])
                          ])
                      ])
                  ]),
                "(@[<2>COMMENT@ "
              ]);
          Curry._3(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                /* Caml_string */Block.__(3, [
                    /* No_padding */0,
                    /* End_of_format */0
                  ]),
                "%S"
              ], param[0]);
          return Curry._2(Ppx_deriving_runtime.Format.fprintf, fmt, /* Format */[
                      /* Formatting_lit */Block.__(17, [
                          /* Close_box */0,
                          /* Char_literal */Block.__(12, [
                              /* ")" */41,
                              /* End_of_format */0
                            ])
                        ]),
                      "@])"
                    ]);
      
    }
  }
}

function show_token(x) {
  return Curry._3(Ppx_deriving_runtime.Format.asprintf, /* Format */[
              /* Alpha */Block.__(15, [/* End_of_format */0]),
              "%a"
            ], pp_token, x);
}

exports.pp_token = pp_token;
exports.show_token = show_token;
/* Ppx_deriving_runtime Not a pure module */
